var A, F,
  slice = [].slice;

A = require('./array');

F = {
  id: function(arg) {
    return arg;
  },
  apply: function(fn) {
    return function(args) {
      return fn.apply(this, args);
    };
  },
  compose: function() {
    var fns, step;
    fns = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    step = function(seed, fn) {
      return fn.apply(null, seed);
    };
    return function() {
      var args;
      args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      return fns.reduce(step, args);
    };
  },
  sequence: function() {
    var fns;
    fns = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    return F.compose.apply(this, A.reverse(fns));
  },
  partial: function() {
    var bound, fn;
    fn = arguments[0], bound = 2 <= arguments.length ? slice.call(arguments, 1) : [];
    return function() {
      var args;
      args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      return fn.apply(this, A.concat(args, bound));
    };
  },
  partialRight: function() {
    var bound, fn;
    fn = arguments[0], bound = 2 <= arguments.length ? slice.call(arguments, 1) : [];
    return function() {
      var args;
      args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      return fn.apply(this, A.concat(args, bound));
    };
  },
  partialReverse: function() {
    var bound, fn;
    fn = arguments[0], bound = 2 <= arguments.length ? slice.call(arguments, 1) : [];
    return function() {
      var args;
      args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      return fn.apply(this, A.concat(args, A.reverse(bound)));
    };
  }
};

module.exports = F;
